//  
//  Copyright (c) 1994 by Mike Romberg (  romberg@md.fsl.noaa.gov )
//
//  This file may be distributed under terms of the GPL
//

#include "memmeter.h"

static const char COLORS[4][33] = { "blue", "yellow", "red", "green" };


MemMeter::MemMeter( XOSView *parent, int x, int y, int width, int height )
: FieldMeter( parent, x, y, width, height, 4, "MEM", "USED/SHAR/BUFF/FREE" ){
  for ( int i = 0 ; i < 4 ; i++ )
    setfieldcolor( i, COLORS[i] );

  char buf[256];  
  meminfo_ = new ifstream( MEMFILENAME );
  meminfo_->getline( buf, 256 );
  fpos_ = meminfo_->tellg();
}

MemMeter::~MemMeter( void ){
  delete meminfo_;
}

void MemMeter::checkevent( void ){
  getmeminfo();
  drawfields();
}

void MemMeter::getmeminfo( void ){
  static char buf[32];
  float used;
  
  meminfo_->seekg( fpos_ );

  *meminfo_ >>buf >>total_ >>used >>fields_[3] >>fields_[1] >>fields_[2];

  fields_[0] = used - fields_[1] - fields_[2];
  if ( fields_[0] < 0 )
    fields_[0] = 0;
}
